import java.util.ArrayList;

interface Verkuppler<T> {
	T[] verkuppeln();
}

class Person {

	private String name;

	public Person(String name) {
		this.name = name;
	}

	public String getName() {
		return this.name;
	}
}

class Paar {
	private Person person1;
	private Person person2;

	public Paar(Person p1, Person p2) {
		this.person1 = p1;
		this.person2 = p2;
	}

	public String toString() {
		return this.person1.getName() + "+" + this.person2.getName();
	}
}

public class UE23Aufgabe13 {

	public static void main(String[] args) {
		PersonArrayList list = new PersonArrayList();
		list.add(new Person("Karl"));
		list.add(new Person("Luise"));
		list.add(new Person("Otto"));
		list.add(new Person("Maria"));
		list.add(new Person("Paul"));
		for (Paar paar : list.verkuppeln()) {
			System.out.println(paar.toString());
		}
	}

}

// gesucht
class PersonArrayList extends ArrayList<Person> implements Verkuppler<Paar> {

	@Override
	public Paar[] verkuppeln() {
		Paar[] paare = new Paar[this.size() / 2];
		for (int i = 0; i < this.size() - 1; i += 2) {
			paare[i / 2] = new Paar(this.get(i), this.get(i + 1));
		}
		return paare;
	}
}
