import java.util.ArrayList;

class Datum implements Comparable<Datum> {
	private int jahr;
	private int monat;
	private int tag;

	public Datum(int jahr, int monat, int tag) {
		this.jahr = jahr;
		this.monat = monat;
		this.tag = tag;
	}

	public void setJahr(int jahr) {
		this.jahr = jahr;
	}

	public int getJahr() {
		return jahr;
	}

	public void setMonat(int monat) {
		this.monat = monat;
	}

	public int getMonat() {
		return monat;
	}

	public void setTag(int tag) {
		this.tag = tag;
	}

	public int getTag() {
		return tag;
	}

	public String toString() {
		return jahr + "/" + monat + "/" + tag;
	}

	@Override
	public int compareTo(Datum o) {
		if (this.jahr < o.jahr) {
			return -1;
		} else if (this.jahr > o.jahr) {
			return 1;
		}
		if (this.monat < o.monat) {
			return -1;
		} else if (this.monat > o.monat) {
			return 1;
		}
		return this.tag - o.tag;
	}
}

public class UE23Aufgabe4 {

	public static void main(String[] args) {
		ArrayList<Datum> daten = new ArrayList<Datum>();
		daten.add(new Datum(1963, 10, 4));
		daten.add(new Datum(1963, 9, 4));
		daten.add(new Datum(1963, 11, 5));
		daten.add(new Datum(1962, 10, 30));
		daten.add(new Datum(1962, 10, 4));
		
		// Collections.sort(daten);
		
		new Sorter<Datum>().sort(daten);
		for (Datum d : daten) {
			System.out.println(d);
		}
	}

}

class Sorter<T extends Comparable<T>> {
	public void sort(ArrayList<T> list) {
		boolean veraendert = true;
		while (veraendert) {
			veraendert = false;
			for (int i = 0; i < list.size() - 1; i++) {
				if (list.get(i).compareTo(list.get(i + 1)) > 0) {
					T help = list.get(i);
					list.set(i, list.get(i + 1));
					list.set(i + 1, help);
					veraendert = true;
				}
			}
		}
	}

	// Alternative
	@SuppressWarnings("unchecked")
	public void sort2(ArrayList<T> list) {
		Object[] menge = list.toArray();
		boolean veraendert = true;
		while (veraendert) {
			veraendert = false;
			for (int i = 0; i < menge.length - 1; i++) {
				if (((T) menge[i]).compareTo((T) menge[i + 1]) > 0) {
					Object help = menge[i];
					menge[i] = menge[i + 1];
					menge[i + 1] = help;
					veraendert = true;
				}
			}
		}
		list.clear();
		for (Object o : menge) {
			list.add((T) o);
		}
	}
}
