import java.util.Iterator;

class Intervall implements Iterable<Integer> {

	private boolean isEmpty;
	private int untergrenze;
	private int obergrenze;

	public Intervall() {
		this.isEmpty = true;
		this.untergrenze = 0;
		this.obergrenze = 0;
	}

	public Intervall(int von, int nach) {
		this.untergrenze = von;
		this.obergrenze = nach;
		if (von > nach) {
			this.isEmpty = true;
		} else {
			this.isEmpty = false;
		}
	}

	public Intervall(Intervall i) {
		this.isEmpty = i.isEmpty;
		this.untergrenze = i.untergrenze;
		this.obergrenze = i.obergrenze;
	}

	@Override
	protected Intervall clone() {
		return new Intervall(this);
	}

	@Override
	public boolean equals(Object obj) {
		Intervall i = (Intervall) obj;
		if (this.isEmpty) {
			return i.isEmpty;
		} else {
			return this.untergrenze == i.untergrenze
					&& this.obergrenze == i.obergrenze;
		}
	}

	@Override
	public String toString() {
		if (this.isEmpty) {
			return "[]";
		} else {
			return "[" + this.untergrenze + "," + this.obergrenze + "]";
		}
	}

	public boolean enthaelt(Intervall i) {
		if (i.isEmpty) {
			return true;
		}
		if (this.isEmpty) {
			return false;
		}
		return this.untergrenze <= i.untergrenze
				&& i.obergrenze <= this.obergrenze;
	}

	public static Intervall schnittmenge(Intervall i1, Intervall i2) {
		if (i1.isEmpty || i2.isEmpty) {
			return new Intervall();
		} else {
			return new Intervall(Math.max(i1.untergrenze, i2.untergrenze),
					Math.min(i1.obergrenze, i2.obergrenze));
		}
	}

	public boolean isEmpty() {
		return this.isEmpty;
	}

	public int getUntergrenze() {
		return this.untergrenze;
	}

	public int getObergrenze() {
		return this.obergrenze;
	}

	@Override
	public Iterator<Integer> iterator() {
		return new IntervallIterator(this);
	}
}

class IntervallIterator implements Iterator<Integer> {

	private int aktuellesElement;
	private Intervall i;

	public IntervallIterator(Intervall intervall) {
		this.i = intervall;
		this.aktuellesElement = intervall.getUntergrenze();
	}

	@Override
	public boolean hasNext() {
		return !this.i.isEmpty()
				&& this.aktuellesElement <= this.i.getObergrenze();
	}

	@Override
	public Integer next() {
		return this.aktuellesElement++;
	}

	@Override
	public void remove() {
		throw new UnsupportedOperationException();
	}

}

public class UE23Aufgabe5 {

	// Testprogramm
	public static void main(String[] args) {
		Intervall intervall = new Intervall(-3, 5);
		for (int i : intervall) {
			System.out.println(i);
		}

		for (int i : new Intervall()) {
			System.out.println(i);
		}
	}

}
